#pragma once

#include <l4/sys/ipc.h>

#include "opener_context_resource.h"
#include "opener_interface.h"
#include "paging.h"
#include "pages.h"
#include "resource.h"

/* Support for providing access to files. */

class OpenerResource : public Resource, public Paging, public Opener
{
public:
    explicit OpenerResource(Pages *pages);

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<Opener *>(this); }

    /* Direct access methods. */

    Pager *open(const char *path, flags_t flags);

    /* Opener interface methods. */

    long context(l4_cap_idx_t *context);
};

// vim: tabstop=4 expandtab shiftwidth=4
